diff -Naurd cluster-3.0.0.rc2/gfs-kernel/src/gfs/gfs_ondisk.h cluster-3.0.0.rc3/gfs-kernel/src/gfs/gfs_ondisk.h
--- cluster-3.0.0.rc2/gfs-kernel/src/gfs/gfs_ondisk.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs-kernel/src/gfs/gfs_ondisk.h	2009-06-11 11:02:55.000000000 +0200
@@ -695,7 +695,7 @@
 void gfs_quota_print(struct gfs_quota *quota);
 void gfs_dinode_print(struct gfs_dinode *dinode);
 void gfs_indirect_print(struct gfs_indirect *indirect);
-void gfs_dirent_print(struct gfs_dirent *dirent, char *name);
+void gfs_dirent_print(struct gfs_dirent *dirent, const char *name);
 void gfs_leaf_print(struct gfs_leaf *leaf);
 void gfs_log_header_print(struct gfs_log_header *head);
 void gfs_desc_print(struct gfs_log_descriptor *desc);
@@ -733,7 +733,7 @@
  */
 
 static void
-print_array(char *title, char *buf, int count)
+print_array(const char *title, char *buf, int count)
 {
 	int x;
 
@@ -1016,20 +1016,20 @@
  */
 
 void
-gfs_rindex_in(struct gfs_rindex *rindex, char *buf)
+gfs_rindex_in(struct gfs_rindex *grindex, char *buf)
 {
 	struct gfs_rindex *str = (struct gfs_rindex *)buf;
 
-	CPIN_64(rindex, str, ri_addr);
-	CPIN_32(rindex, str, ri_length);
-	CPIN_32(rindex, str, ri_pad);
+	CPIN_64(grindex, str, ri_addr);
+	CPIN_32(grindex, str, ri_length);
+	CPIN_32(grindex, str, ri_pad);
 
-	CPIN_64(rindex, str, ri_data1);
-	CPIN_32(rindex, str, ri_data);
+	CPIN_64(grindex, str, ri_data1);
+	CPIN_32(grindex, str, ri_data);
 
-	CPIN_32(rindex, str, ri_bitbytes);
+	CPIN_32(grindex, str, ri_bitbytes);
 
-	CPIN_08(rindex, str, ri_reserved, 64);
+	CPIN_08(grindex, str, ri_reserved, 64);
 }
 
 /**
@@ -1040,20 +1040,20 @@
  */
 
 void
-gfs_rindex_out(struct gfs_rindex *rindex, char *buf)
+gfs_rindex_out(struct gfs_rindex *grindex, char *buf)
 {
 	struct gfs_rindex *str = (struct gfs_rindex *)buf;
 
-	CPOUT_64(rindex, str, ri_addr);
-	CPOUT_32(rindex, str, ri_length);
-	CPOUT_32(rindex, str, ri_pad);
+	CPOUT_64(grindex, str, ri_addr);
+	CPOUT_32(grindex, str, ri_length);
+	CPOUT_32(grindex, str, ri_pad);
 
-	CPOUT_64(rindex, str, ri_data1);
-	CPOUT_32(rindex, str, ri_data);
+	CPOUT_64(grindex, str, ri_data1);
+	CPOUT_32(grindex, str, ri_data);
 
-	CPOUT_32(rindex, str, ri_bitbytes);
+	CPOUT_32(grindex, str, ri_bitbytes);
 
-	CPOUT_08(rindex, str, ri_reserved, 64);
+	CPOUT_08(grindex, str, ri_reserved, 64);
 }
 
 /**
@@ -1454,7 +1454,7 @@
  */
 
 void
-gfs_dirent_print(struct gfs_dirent *de, char *name)
+gfs_dirent_print(struct gfs_dirent *de, const char *name)
 {
 	char buf[GFS_FNAMESIZE + 1];
 
diff -Naurd cluster-3.0.0.rc2/gfs-kernel/src/gfs/ioctl.c cluster-3.0.0.rc3/gfs-kernel/src/gfs/ioctl.c
--- cluster-3.0.0.rc2/gfs-kernel/src/gfs/ioctl.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs-kernel/src/gfs/ioctl.c	2009-06-11 11:02:55.000000000 +0200
@@ -8,6 +8,7 @@
 #include <asm/uaccess.h>
 #include <linux/compat.h>
 #include <linux/cred.h>
+#include <linux/vmalloc.h>
 
 #include "gfs_ioctl.h"
 #include "gfs.h"
@@ -55,7 +56,7 @@
 	if (size > gi->gi_size)
 		size = gi->gi_size;
 
-        buf = kmalloc(size, GFP_KERNEL);
+        buf = vmalloc(size);
         if (!buf)
                 return -ENOMEM;
 
@@ -69,7 +70,7 @@
 		error = count + 1;
 
  out:
-	kfree(buf);
+	vfree(buf);
 
 	return error;
 }
diff -Naurd cluster-3.0.0.rc2/gfs-kernel/src/gfs/ops_fstype.c cluster-3.0.0.rc3/gfs-kernel/src/gfs/ops_fstype.c
--- cluster-3.0.0.rc2/gfs-kernel/src/gfs/ops_fstype.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/gfs-kernel/src/gfs/ops_fstype.c	2009-06-11 11:02:55.000000000 +0200
@@ -809,7 +809,7 @@
 
 struct file_system_type gfs_fs_type = {
 	.name = "gfs",
-	.fs_flags = FS_REQUIRES_DEV,
+	.fs_flags = FS_REQUIRES_DEV | FS_HAS_FREEZE,
 	.get_sb = gfs_get_sb,
 	.kill_sb = gfs_kill_sb,
 	.owner = THIS_MODULE,
diff -Naurd cluster-3.0.0.rc2/group/daemon/app.c cluster-3.0.0.rc3/group/daemon/app.c
--- cluster-3.0.0.rc2/group/daemon/app.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/daemon/app.c	2009-06-11 11:02:55.000000000 +0200
@@ -10,7 +10,7 @@
 	int nodeid;
 };
 
-char *msg_type(int type)
+const char *msg_type(int type)
 {
 	switch (type) {
 	case MSG_APP_STOPPED:
@@ -51,7 +51,7 @@
 	msg->ms_event_id	= le64_to_cpu(msg->ms_event_id);
 }
 
-uint64_t make_event_id(group_t *g, int state, int nodeid)
+static uint64_t make_event_id(group_t *g, int state, int nodeid)
 {
 	uint64_t id;
 	uint32_t n = nodeid;
@@ -79,7 +79,7 @@
 	return id;
 }
 
-void free_event(event_t *ev)
+static void free_event(event_t *ev)
 {
 	struct nodeid *id, *id_safe;
 
@@ -90,7 +90,7 @@
 	free(ev);
 }
 
-int event_id_to_nodeid(uint64_t id)
+static int event_id_to_nodeid(uint64_t id)
 {
 	int nodeid;
 	uint64_t n = id >> 32;
@@ -98,7 +98,7 @@
 	return nodeid;
 }
 
-int event_id_to_type(uint64_t id)
+static int event_id_to_type(uint64_t id)
 {
 	uint64_t n;
 	n = id & 0x000000000000FFFF;
@@ -119,7 +119,7 @@
 	struct save_msg *save, *tmp;
 	node_t *node;
 	int nodeid, type;
-	char *state_str;
+	const char *state_str;
 
 	list_for_each_entry_safe(save, tmp, &g->messages, list) {
 		if (save->msg.ms_type == MSG_APP_INTERNAL)
@@ -296,7 +296,7 @@
 	return rs;
 }
 
-void _del_recovery_set(group_t *g, int nodeid, int purge)
+static void _del_recovery_set(group_t *g, int nodeid, int purge)
 {
 	struct recovery_set *rs, *rs2;
 	struct recovery_entry *re, *re2;
@@ -352,7 +352,7 @@
    one failed nodeid).  Remove this group from recovery sets for those nodeids
    and free any recovery sets that are now completed. */
 
-void del_recovery_set(group_t *g, event_t *ev, int purge)
+static void del_recovery_set(group_t *g, event_t *ev, int purge)
 {
 	struct nodeid *id;
 
@@ -374,7 +374,7 @@
    callbacks, not cman callbacks, so that's why we might be trying
    to do recovery without having heard from cman yet.] */
 
-int cman_quorum_updated(void)
+static int cman_quorum_updated(void)
 {
 	struct recovery_set *rs;
 
@@ -388,7 +388,7 @@
 	return 1;
 }
 
-int is_recovery_event(event_t *ev)
+static int is_recovery_event(event_t *ev)
 {
 	if (event_id_to_type(ev->id) == 3)
 		return 1;
@@ -447,6 +447,7 @@
 	return 1;
 }
 
+#if 0
 void dump_recovery_sets(void)
 {
 	struct recovery_set *rs;
@@ -461,6 +462,7 @@
 		}
 	}
 }
+#endif
 
 static int group_in_recovery_set(struct recovery_set *rs, group_t *g)
 {
@@ -600,7 +602,7 @@
 	}
 }
 
-event_t *search_event(group_t *g, int nodeid)
+static event_t *search_event(group_t *g, int nodeid)
 {
 	event_t *ev;
 
@@ -611,7 +613,7 @@
 	return NULL;
 }
 
-void dump_queued_events(group_t *g)
+static void dump_queued_events(group_t *g)
 {
 	event_t *ev;
 
@@ -755,7 +757,7 @@
    groupd_down() will fill in stops for us for nodes that fail before
    sending stopped for our leave. */
 
-void finalize_our_leave(group_t *g)
+static void finalize_our_leave(group_t *g)
 {
 	struct recovery_set *rs;
 	struct recovery_entry *re, *re2;
@@ -851,7 +853,7 @@
 {
 	group_t *g;
 	event_t *ev;
-	char *state;
+	const char *state;
 
 	g = find_group_level(name, level);
 	if (!g) {
@@ -877,7 +879,7 @@
 	return send_started(g);
 }
 
-char *ev_state_str(event_t *ev)
+const char *ev_state_str(event_t *ev)
 {
 	switch (ev->state) {
 	case EST_JOIN_BEGIN:
@@ -927,7 +929,7 @@
 	return i;
 }
 
-int event_state_begin(app_t *a)
+static int event_state_begin(app_t *a)
 {
 	if (a->current_event->state == EST_JOIN_BEGIN ||
 	    a->current_event->state == EST_LEAVE_BEGIN ||
@@ -954,6 +956,7 @@
 	return FALSE;
 }
 
+#if 0
 int event_state_all_stopped(app_t *a)
 {
 	if (a->current_event->state == EST_JOIN_ALL_STOPPED ||
@@ -962,8 +965,9 @@
 		return TRUE;
 	return FALSE;
 }
+#endif
 
-int event_state_all_started(app_t *a)
+static int event_state_all_started(app_t *a)
 {
 	if (a->current_event->state == EST_JOIN_ALL_STARTED ||
 	    a->current_event->state == EST_LEAVE_ALL_STARTED ||
@@ -1498,7 +1502,7 @@
 /* handle a node failure while processing an event. returning > 0 means
    we want process_current_event() to be called for the group */
 
-int recover_current_event(group_t *g)
+static int recover_current_event(group_t *g)
 {
 	app_t *a = g->app;
 	event_t *ev, *rev;
diff -Naurd cluster-3.0.0.rc2/group/daemon/cpg.c cluster-3.0.0.rc3/group/daemon/cpg.c
--- cluster-3.0.0.rc2/group/daemon/cpg.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/daemon/cpg.c	2009-06-11 11:02:55.000000000 +0200
@@ -48,7 +48,7 @@
 
 static void block_old_nodes(void);
 
-static char *mode_str(int m)
+static const char *mode_str(int m)
 {
 	switch (m) {
 	case GROUP_PENDING:
@@ -476,7 +476,7 @@
 	return send_message_groupd(&g, &msg, sizeof(msg), MSG_GLOBAL_ID);
 }
 
-void process_groupd_confchg(void)
+static void process_groupd_confchg(void)
 {
 	group_t *g;
 	struct recovery_set *rs;
@@ -598,7 +598,7 @@
 	return 0;
 }
 
-group_t *find_group_by_handle(cpg_handle_t h)
+static group_t *find_group_by_handle(cpg_handle_t h)
 {
 	group_t *g;
 
@@ -609,7 +609,7 @@
 	return NULL;
 }
 
-void deliver_cb(cpg_handle_t handle,
+static void deliver_cb(cpg_handle_t handle,
 		const struct cpg_name *group_name,
 		uint32_t nodeid, uint32_t pid,
 		void *data, size_t data_len)
@@ -650,7 +650,7 @@
 		g = find_group_level(name, msg->ms_level);
 		if (!g) {
 			if (daemon_debug_verbose > 1) {
-				log_print("%d:%s RECV len %d %s from %d, "
+				log_print("%d:%s RECV len %zd %s from %d, "
 					  "no group",
 				  	  msg->ms_level, name, data_len,
 				  	  msg_type(msg->ms_type), nodeid);
@@ -675,7 +675,7 @@
 	}
 
 	if (daemon_debug_verbose > 1)
-		log_group(g, "RECV len %d %s from %d", data_len,
+		log_group(g, "RECV len %zd %s from %d", data_len,
 			  msg_type(msg->ms_type), nodeid);
 
 	save = malloc(sizeof(struct save_msg));
@@ -696,7 +696,7 @@
 	queue_app_message(g, save);
 }
 
-void process_confchg(void)
+static void process_confchg(void)
 {
 	group_t *g;
 	int i;
@@ -744,7 +744,7 @@
 	}
 }
 
-void confchg_cb(cpg_handle_t handle,
+static void confchg_cb(cpg_handle_t handle,
 	        const struct cpg_name *group_name,
 		const struct cpg_address *member_list,
 		size_t member_list_entries,
@@ -754,7 +754,7 @@
 		size_t joined_list_entries)
 {
 	group_t *g;
-	char *name = "unknown";
+	const char *name = "unknown";
 	int i, level = -1;
 
 	if (handle == groupd_handle)
@@ -775,15 +775,15 @@
 	saved_handle = handle;
 
 	if (left_list_entries > MAX_GROUP_MEMBERS) {
-		log_debug("left_list_entries %d", left_list_entries);
+		log_debug("left_list_entries %zd", left_list_entries);
 		left_list_entries = MAX_GROUP_MEMBERS;
 	}
 	if (joined_list_entries > MAX_GROUP_MEMBERS) {
-		log_debug("joined_list_entries %d", joined_list_entries);
+		log_debug("joined_list_entries %zd", joined_list_entries);
 		joined_list_entries = MAX_GROUP_MEMBERS;
 	}
 	if (member_list_entries > MAX_GROUP_MEMBERS) {
-		log_debug("member_list_entries %d", joined_list_entries);
+		log_debug("member_list_entries %zd", joined_list_entries);
 		member_list_entries = MAX_GROUP_MEMBERS;
 	}
 
@@ -812,7 +812,7 @@
 	.cpg_confchg_fn = confchg_cb,
 };
 
-void process_cpg(int ci)
+static void process_cpg(int ci)
 {
 	group_t *g = NULL;
 	cpg_error_t error;
@@ -1047,7 +1047,7 @@
 	return _send_message(g->cpg_handle, g, buf, len);
 }
 
-static void block_old_group(char *name, int level)
+static void block_old_group(const char *name, int level)
 {
 	group_t *g;
 	app_t *a;
diff -Naurd cluster-3.0.0.rc2/group/daemon/gd_internal.h cluster-3.0.0.rc3/group/daemon/gd_internal.h
--- cluster-3.0.0.rc2/group/daemon/gd_internal.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/daemon/gd_internal.h	2009-06-11 11:02:55.000000000 +0200
@@ -256,7 +256,7 @@
 int queue_app_message(group_t *g, struct save_msg *save);
 int do_stopdone(char *name, int level);
 int do_startdone(char *name, int level, int event_nr);
-char *ev_state_str(event_t *ev);
+const char *ev_state_str(event_t *ev);
 event_t *find_queued_recover_event(group_t *g);
 void extend_recover_event(group_t *g, event_t *ev, int nodeid);
 int process_apps(void);
@@ -270,15 +270,15 @@
 void msg_bswap_in(msg_t *msg);
 struct recovery_set *get_recovery_set(int nodeid);
 void groupd_down(int nodeid);
-char *msg_type(int type);
+const char *msg_type(int type);
 int process_app(group_t *g);
 int is_our_join(event_t *ev);
 void purge_node_messages(group_t *g, int nodeid);
 
 /* main.c */
-void read_ccs_name(char *path, char *name);
-void read_ccs_yesno(char *path, int *yes, int *no);
-void read_ccs_int(char *path, int *config_val);
+void read_ccs_name(const char *path, char *name);
+void read_ccs_yesno(const char *path, int *yes, int *no);
+void read_ccs_int(const char *path, int *config_val);
 void app_stop(app_t *a);
 void app_setid(app_t *a);
 void app_start(app_t *a);
@@ -312,13 +312,13 @@
 int do_leave(char *name, int level);
 node_t *new_node(int nodeid);
 group_t *find_group_level(char *name, int level);
-int create_group(char *name, int level, group_t **g_out);
+int create_group(const char *name, int level, group_t **g_out);
 app_t *create_app(group_t *g);
 
 /* logging.c */
 
 void init_logging(void);
-void setup_logging();
+void setup_logging(void);
 void close_logging(void);
 
 #endif				/* __GD_INTERNAL_DOT_H__ */
diff -Naurd cluster-3.0.0.rc2/group/daemon/joinleave.c cluster-3.0.0.rc3/group/daemon/joinleave.c
--- cluster-3.0.0.rc2/group/daemon/joinleave.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/daemon/joinleave.c	2009-06-11 11:02:55.000000000 +0200
@@ -15,7 +15,7 @@
 	return NULL;
 }
 
-int create_group(char *name, int level, group_t **g_out)
+int create_group(const char *name, int level, group_t **g_out)
 {
 	group_t *g;
 
@@ -38,7 +38,7 @@
 	return 0;
 }
 
-void free_group_memb(group_t *g)
+static void free_group_memb(group_t *g)
 {
 	node_t *node, *n;
 
diff -Naurd cluster-3.0.0.rc2/group/daemon/main.c cluster-3.0.0.rc3/group/daemon/main.c
--- cluster-3.0.0.rc2/group/daemon/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/daemon/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -30,7 +30,7 @@
 	int rv, off = 0;
 
 	while (off < count) {
-		rv = read(fd, buf + off, count - off);
+		rv = read(fd, (char *)buf + off, count - off);
 		if (rv == 0)
 			return -1;
 		if (rv == -1 && errno == EINTR)
@@ -47,7 +47,7 @@
 	int rv, off = 0;
 
  retry:
-	rv = write(fd, buf + off, count);
+	rv = write(fd, (char *)buf + off, count);
 	if (rv == -1 && errno == EINTR)
 		goto retry;
 	if (rv < 0) {
@@ -63,7 +63,7 @@
 	return 0;
 }
 
-void read_ccs_name(char *path, char *name)
+void read_ccs_name(const char *path, char *name)
 {
 	char *str;
 	int error;
@@ -77,7 +77,7 @@
 	free(str);
 }
 
-void read_ccs_yesno(char *path, int *yes, int *no)
+void read_ccs_yesno(const char *path, int *yes, int *no)
 {
 	char *str;
 	int error;
@@ -98,7 +98,7 @@
 	free(str);
 }
 
-void read_ccs_int(char *path, int *config_val)
+void read_ccs_int(const char *path, int *config_val)
 {
 	char *str;
 	int val;
@@ -124,7 +124,7 @@
 #define GROUPD_WAIT_PATH "/cluster/group/@groupd_wait"
 #define GROUPD_MODE_DELAY_PATH "/cluster/group/@groupd_mode_delay"
 
-int setup_ccs(void)
+static int setup_ccs(void)
 {
 	int cd;
 
@@ -150,7 +150,7 @@
 	return 0;
 }
 
-void close_ccs(void)
+static void close_ccs(void)
 {
 	ccs_disconnect(ccs_handle);
 }
@@ -297,7 +297,7 @@
 	DO_GET_VERSION,
 };
 
-int get_action(char *buf)
+static int get_action(char *buf)
 {
 	char act[16];
 	int i;
@@ -441,7 +441,7 @@
 	data->id = g->global_id;
 
 	if (g->app && g->app->current_event) {
-		event_t *ev = g->app->current_event;
+		ev = g->app->current_event;
 		data->event_state = ev->state;
 		data->event_nodeid = ev->nodeid;
 		data->event_id = ev->id;
@@ -697,7 +697,7 @@
 	log_debug("client connection %d fd %d", i, fd);
 }
 
-static int setup_listener(char *sock_path)
+static int setup_listener(const char *sock_path)
 {
 	struct sockaddr_un addr;
 	socklen_t addrlen;
diff -Naurd cluster-3.0.0.rc2/group/dlm_controld/action.c cluster-3.0.0.rc3/group/dlm_controld/action.c
--- cluster-3.0.0.rc2/group/dlm_controld/action.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/dlm_controld/action.c	2009-06-11 11:02:55.000000000 +0200
@@ -18,7 +18,8 @@
 static int get_mountgroup_name(uint32_t mg_id)
 {
 	char path[PATH_MAX];
-	char *fsname, *fsdir;
+	char *fsname;
+	const char *fsdir;
 	DIR *d;
 	FILE *file;
 	struct dirent *de;
@@ -153,7 +154,7 @@
 	ls->associated_mg_id = mg_id;
 }
 
-static int do_sysfs(char *name, char *file, char *val)
+static int do_sysfs(const char *name, const char *file, char *val)
 {
 	char fname[512];
 	int rv, fd;
@@ -246,7 +247,7 @@
 	return 0;
 }
 
-static int create_path(char *path)
+static int create_path(const char *path)
 {
 	mode_t old_umask;
 	int rv;
@@ -685,7 +686,7 @@
 		return -1;
 	}
 
-	rv = do_write(fd, "1", strlen("1"));
+	rv = do_write(fd, (void *)"1", strlen("1"));
 	if (rv < 0) {
 		log_error("%s: write failed: %d", path, errno);
 		close(fd);
@@ -877,7 +878,7 @@
 		log_error("Is dlm missing from kernel? No misc devices found.");
 }
 
-static int find_udev_device(char *path, uint32_t minor)
+static int find_udev_device(const char *path, uint32_t minor)
 {
 	struct stat st;
 	int i;
diff -Naurd cluster-3.0.0.rc2/group/dlm_controld/config.c cluster-3.0.0.rc3/group/dlm_controld/config.c
--- cluster-3.0.0.rc2/group/dlm_controld/config.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/dlm_controld/config.c	2009-06-11 11:02:55.000000000 +0200
@@ -127,7 +127,7 @@
 	return w;
 }
 
-void read_ccs_name(char *path, char *name)
+void read_ccs_name(const char *path, char *name)
 {
 	char *str;
 	int error;
@@ -141,7 +141,7 @@
 	free(str);
 }
 
-void read_ccs_yesno(char *path, int *yes, int *no)
+void read_ccs_yesno(const char *path, int *yes, int *no)
 {
 	char *str;
 	int error;
@@ -162,7 +162,7 @@
 	free(str);
 }
 
-int read_ccs_int(char *path, int *config_val)
+int read_ccs_int(const char *path, int *config_val)
 {
 	char *str;
 	int val;
@@ -185,7 +185,7 @@
 	return 0;
 }
 
-static void read_ccs_protocol(char *path, int *config_val)
+static void read_ccs_protocol(const char *path, int *config_val)
 {
 	char *str;
 	int val;
diff -Naurd cluster-3.0.0.rc2/group/dlm_controld/cpg.c cluster-3.0.0.rc3/group/dlm_controld/cpg.c
--- cluster-3.0.0.rc2/group/dlm_controld/cpg.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/dlm_controld/cpg.c	2009-06-11 11:02:55.000000000 +0200
@@ -127,7 +127,7 @@
 	}
 }
 
-char *msg_name(int type)
+const char *msg_name(int type)
 {
 	switch (type) {
 	case DLM_MSG_PROTOCOL:
@@ -1369,7 +1369,7 @@
 	}
 
 	if (len < sizeof(*hd)) {
-		log_error("deliver_cb short message %d", len);
+		log_error("deliver_cb short message %zd", len);
 		return;
 	}
 
@@ -1960,7 +1960,7 @@
 	struct dlm_header *hd;
 
 	if (len < sizeof(*hd)) {
-		log_error("deliver_cb short message %d", len);
+		log_error("deliver_cb short message %zd", len);
 		return;
 	}
 
diff -Naurd cluster-3.0.0.rc2/group/dlm_controld/deadlock.c cluster-3.0.0.rc3/group/dlm_controld/deadlock.c
--- cluster-3.0.0.rc2/group/dlm_controld/deadlock.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/dlm_controld/deadlock.c	2009-06-11 11:02:55.000000000 +0200
@@ -97,7 +97,7 @@
 	return __dlm_compat_matrix[mode1 + 1][mode2 + 1];
 }
 
-static char *status_str(int lksts)
+static const char *status_str(int lksts)
 {
 	switch (lksts) {
 	case DLM_LKSTS_WAITING:
diff -Naurd cluster-3.0.0.rc2/group/dlm_controld/dlm_daemon.h cluster-3.0.0.rc3/group/dlm_controld/dlm_daemon.h
--- cluster-3.0.0.rc2/group/dlm_controld/dlm_daemon.h	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/dlm_controld/dlm_daemon.h	2009-06-11 11:02:55.000000000 +0200
@@ -225,9 +225,9 @@
 /* config.c */
 int setup_ccs(void);
 void close_ccs(void);
-void read_ccs_name(char *path, char *name);
-void read_ccs_yesno(char *path, int *yes, int *no);
-int read_ccs_int(char *path, int *config_val);
+void read_ccs_name(const char *path, char *name);
+void read_ccs_yesno(const char *path, int *yes, int *no);
+int read_ccs_int(const char *path, int *config_val);
 int get_weight(int nodeid, char *lockspace);
 
 /* cpg.c */
@@ -239,7 +239,7 @@
 void dlm_send_message(struct lockspace *ls, char *buf, int len);
 int dlm_join_lockspace(struct lockspace *ls);
 int dlm_leave_lockspace(struct lockspace *ls);
-char *msg_name(int type);
+const char *msg_name(int type);
 void update_flow_control_status(void);
 int set_node_info(struct lockspace *ls, int nodeid, struct dlmc_node *node);
 int set_lockspace_info(struct lockspace *ls, struct dlmc_lockspace *lockspace);
@@ -274,7 +274,7 @@
 void client_back(int ci, int fd);
 struct lockspace *find_ls(char *name);
 struct lockspace *find_ls_id(uint32_t id);
-char *dlm_mode_str(int mode);
+const char *dlm_mode_str(int mode);
 void cluster_dead(int ci);
 
 /* member_cman.c */
@@ -344,7 +344,7 @@
 
 /* logging.c */
 void init_logging(void);
-void setup_logging();
+void setup_logging(void);
 void close_logging(void);
 
 /* crc.c */
diff -Naurd cluster-3.0.0.rc2/group/dlm_controld/main.c cluster-3.0.0.rc3/group/dlm_controld/main.c
--- cluster-3.0.0.rc2/group/dlm_controld/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/dlm_controld/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -32,7 +32,7 @@
 	int rv, off = 0;
 
 	while (off < count) {
-		rv = read(fd, buf + off, count - off);
+		rv = read(fd, (char *)buf + off, count - off);
 		if (rv == 0)
 			return -1;
 		if (rv == -1 && errno == EINTR)
@@ -49,7 +49,7 @@
 	int rv, off = 0;
 
  retry:
-	rv = write(fd, buf + off, count);
+	rv = write(fd, (char *)buf + off, count);
 	if (rv == -1 && errno == EINTR)
 		goto retry;
 	if (rv < 0) {
@@ -268,7 +268,7 @@
 	return rp;
 }
 
-char *dlm_mode_str(int mode)
+const char *dlm_mode_str(int mode)
 {
 	switch (mode) {
 	case DLM_LOCK_IV:
@@ -719,7 +719,7 @@
 	log_debug("client connection %d fd %d", i, fd);
 }
 
-static int setup_listener(char *sock_path)
+static int setup_listener(const char *sock_path)
 {
 	struct sockaddr_un addr;
 	socklen_t addrlen;
@@ -754,12 +754,12 @@
 	return s;
 }
 
-void query_lock(void)
+static void query_lock(void)
 {
 	pthread_mutex_lock(&query_mutex);
 }
 
-void query_unlock(void)
+static void query_unlock(void)
 {
 	pthread_mutex_unlock(&query_mutex);
 }
@@ -1276,7 +1276,7 @@
 	}
 	lockfile();
 	init_logging();
-	log_level(LOG_INFO, "dlm_controld %s", RELEASE_VERSION);
+	log_level(LOG_INFO, "dlm_controld %s started", RELEASE_VERSION);
 	signal(SIGTERM, sigterm_handler);
 	set_scheduler();
 	set_oom_adj(-16);
diff -Naurd cluster-3.0.0.rc2/group/dlm_controld/netlink.c cluster-3.0.0.rc3/group/dlm_controld/netlink.c
--- cluster-3.0.0.rc2/group/dlm_controld/netlink.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/dlm_controld/netlink.c	2009-06-11 11:02:55.000000000 +0200
@@ -9,7 +9,7 @@
 
 /* FIXME: look into using libnl/libnetlink */
 
-#define GENLMSG_DATA(glh)       ((void *)(NLMSG_DATA(glh) + GENL_HDRLEN))
+#define GENLMSG_DATA(glh)       ((void *)((char *)NLMSG_DATA(glh) + GENL_HDRLEN))
 #define GENLMSG_PAYLOAD(glh)    (NLMSG_PAYLOAD(glh, 0) - GENL_HDRLEN)
 #define NLA_DATA(na)	    	((void *)((char*)(na) + NLA_HDRLEN))
 #define NLA_PAYLOAD(len)	(len - NLA_HDRLEN)
diff -Naurd cluster-3.0.0.rc2/group/dlm_controld/plock.c cluster-3.0.0.rc3/group/dlm_controld/plock.c
--- cluster-3.0.0.rc2/group/dlm_controld/plock.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/dlm_controld/plock.c	2009-06-11 11:02:55.000000000 +0200
@@ -114,7 +114,7 @@
 	i->owner	= le64_to_cpu(i->owner);
 }
 
-static char *op_str(int optype)
+static const char *op_str(int optype)
 {
 	switch (optype) {
 	case DLM_PLOCK_OP_LOCK:
@@ -128,7 +128,7 @@
 	}
 }
 
-static char *ex_str(int optype, int ex)
+static const char *ex_str(int optype, int ex)
 {
 	if (optype == DLM_PLOCK_OP_UNLOCK || optype == DLM_PLOCK_OP_GET)
 		return "-";
@@ -1544,11 +1544,6 @@
 	}
 }
 
-void plock_exit(void)
-{
-	saCkptFinalize(system_ckpt_handle);
-}
-
 /* locks still marked SYNCING should not go into the ckpt; the new node
    will get those locks by receiving PLOCK_SYNC messages */
 
@@ -1670,7 +1665,7 @@
 	log_group(ls, "unlink ckpt %llx", (unsigned long long)h);
 
 	if (!h)
-		return;
+		return ret;
 
  unlink_retry:
 	rv = saCkptCheckpointUnlink(system_ckpt_handle, name);
diff -Naurd cluster-3.0.0.rc2/group/gfs_control/main.c cluster-3.0.0.rc3/group/gfs_control/main.c
--- cluster-3.0.0.rc2/group/gfs_control/main.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/gfs_control/main.c	2009-06-11 11:02:55.000000000 +0200
@@ -23,7 +23,6 @@
 #define OP_LEAVE			5
 #define OP_JOINLEAVE			6
 
-static char *prog_name;
 static char *fsname;
 static int operation;
 static int opt_ind;
@@ -36,7 +35,7 @@
 struct gfsc_node nodes[MAX_NODES];
 
 
-static void print_usage(void)
+static void print_usage(const char *prog_name)
 {
 	printf("Usage:\n");
 	printf("\n");
@@ -64,13 +63,13 @@
 			break;
 
 		case 'h':
-			print_usage();
+			print_usage(argv[0]);
 			exit(EXIT_SUCCESS);
 			break;
 
 		case 'V':
 			printf("%s %s (built %s %s)\n",
-				prog_name, RELEASE_VERSION, __DATE__, __TIME__);
+				argv[0], RELEASE_VERSION, __DATE__, __TIME__);
 			/* printf("%s\n", REDHAT_COPYRIGHT); */
 			exit(EXIT_SUCCESS);
 			break;
@@ -124,7 +123,7 @@
 	}
 
 	if (!operation || !opt_ind) {
-		print_usage();
+		print_usage(argv[0]);
 		exit(EXIT_FAILURE);
 	}
 
@@ -141,7 +140,7 @@
 	int rv, off = 0;
 
  retry:
-	rv = write(fd, buf + off, count);
+	rv = write(fd, (char *)buf + off, count);
 	if (rv == -1 && errno == EINTR)
 		goto retry;
 	if (rv < 0)
@@ -155,7 +154,7 @@
 	return 0;
 }
 
-void do_leave(char *table)
+static void do_leave(char *table)
 {
 	struct gfsc_mount_args ma;
 	int rv;
@@ -169,7 +168,7 @@
 		fprintf(stderr, "gfs_controld leave error %d\n", rv);
 }
 
-char *mg_flags_str(uint32_t flags)
+static char *mg_flags_str(uint32_t flags)
 {
 	static char str[128];
 	int i = 0;
@@ -214,7 +213,7 @@
 	return str;
 }
 
-char *node_mount_str(uint32_t flags)
+static char *node_mount_str(uint32_t flags)
 {
 	static char str[128];
 	int i = 0;
@@ -246,7 +245,7 @@
 	return str;
 }
 
-int member_int(struct gfsc_node *n)
+static int member_int(struct gfsc_node *n)
 {
 	if (n->flags & GFSC_NF_DISALLOWED)
 		return -1;
@@ -255,7 +254,7 @@
 	return 0;
 }
 
-char *condition_str(int cond)
+static const char *condition_str(int cond)
 {
 	switch (cond) {
 	case 0:
@@ -273,9 +272,9 @@
 	}
 }
 
-static void show_nodeids(int count, struct gfsc_node *nodes)
+static void show_nodeids(int count, struct gfsc_node *nodes_in)
 {
-	struct gfsc_node *n = nodes;
+	struct gfsc_node *n = nodes_in;
 	int i;
 
 	for (i = 0; i < count; i++) {
@@ -346,9 +345,9 @@
 	show_nodeids(node_count, nodes);
 }
 
-static void show_all_nodes(int count, struct gfsc_node *nodes)
+static void show_all_nodes(int count, struct gfsc_node *nodes_in)
 {
-	struct gfsc_node *n = nodes;
+	struct gfsc_node *n = nodes_in;
 	int i;
 
 	for (i = 0; i < count; i++) {
@@ -439,7 +438,6 @@
 
 int main(int argc, char **argv)
 {
-	prog_name = argv[0];
 	decode_arguments(argc, argv);
 
 	switch (operation) {
diff -Naurd cluster-3.0.0.rc2/group/gfs_controld/config.c cluster-3.0.0.rc3/group/gfs_controld/config.c
--- cluster-3.0.0.rc2/group/gfs_controld/config.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/gfs_controld/config.c	2009-06-11 11:02:55.000000000 +0200
@@ -53,7 +53,7 @@
 int cfgd_drop_resources_count	= DEFAULT_DROP_RESOURCES_COUNT;
 int cfgd_drop_resources_age	= DEFAULT_DROP_RESOURCES_AGE;
 
-void read_ccs_name(char *path, char *name)
+void read_ccs_name(const char *path, char *name)
 {
 	char *str;
 	int error;
@@ -67,7 +67,7 @@
 	free(str);
 }
 
-void read_ccs_yesno(char *path, int *yes, int *no)
+void read_ccs_yesno(const char *path, int *yes, int *no)
 {
 	char *str;
 	int error;
@@ -88,7 +88,7 @@
 	free(str);
 }
 
-int read_ccs_int(char *path, int *config_val)
+int read_ccs_int(const char *path, int *config_val)
 {
 	char *str;
 	int val;
diff -Naurd cluster-3.0.0.rc2/group/gfs_controld/cpg-new.c cluster-3.0.0.rc3/group/gfs_controld/cpg-new.c
--- cluster-3.0.0.rc2/group/gfs_controld/cpg-new.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/gfs_controld/cpg-new.c	2009-06-11 11:02:55.000000000 +0200
@@ -261,7 +261,7 @@
 static void send_withdraw_acks(struct mountgroup *mg);
 static void leave_mountgroup(struct mountgroup *mg, int mnterr);
 
-static char *msg_name(int type)
+static const char *msg_name(int type)
 {
 	switch (type) {
 	case GFS_MSG_PROTOCOL:
@@ -2544,7 +2544,7 @@
 	}
 
 	if (len < sizeof(*hd)) {
-		log_error("deliver_cb short message %d", len);
+		log_error("deliver_cb short message %zd", len);
 		return;
 	}
 
@@ -3150,7 +3150,7 @@
 	struct gfs_header *hd;
 
 	if (len < sizeof(*hd)) {
-		log_error("deliver_cb short message %d", len);
+		log_error("deliver_cb short message %zd", len);
 		return;
 	}
 
diff -Naurd cluster-3.0.0.rc2/group/gfs_controld/cpg-old.c cluster-3.0.0.rc3/group/gfs_controld/cpg-old.c
--- cluster-3.0.0.rc2/group/gfs_controld/cpg-old.c	2009-05-07 09:09:32.000000000 +0200
+++ cluster-3.0.0.rc3/group/gfs_controld/cpg-old.c	2009-06-11 11:02:55.000000000 +0200
@@ -45,7 +45,7 @@
 static void send_journals(struct mountgroup *mg, int nodeid);
 
 
-static char *msg_name(int type)
+static const char *msg_name(int type)
 {
 	switch (type) {
 	case MSG_JOURNAL:
@@ -183,7 +183,7 @@
 	sm->len = len;
 	sm->nodeid = from;
 
-	log_group(mg, "save %s from %d len %d", msg_name(type), from, len);
+	log_group(mg, "save %s from %d len %zd", msg_name(type), from, len);
 
 	list_add_tail(&sm->list, &mg->saved_messages);
 }
@@ -209,7 +209,7 @@
 	return 0;
 }
 
-int remote_first_mounter_recovery(struct mountgroup *mg)
+static int remote_first_mounter_recovery(struct mountgroup *mg)
 {
 	int nodeid;
 
@@ -345,7 +345,7 @@
 			break;
 		}
 
-		log_group(mg, "receive_recovery_status from %d len %d "
+		log_group(mg, "receive_recovery_status from %d len %zd "
 			  "nodeid %d jid %d status %d found %d",
 			  from, len, nodeid, jid, status, found);
 	}
@@ -506,7 +506,7 @@
 static void receive_mount_status(struct mountgroup *mg, char *buf, size_t len,
 				 int from)
 {
-	log_group(mg, "receive_mount_status from %d len %d last_cb %d",
+	log_group(mg, "receive_mount_status from %d len %zd last_cb %d",
 		  from, len, mg->last_callback);
 
 	if (!mg->got_our_options) {
@@ -917,7 +917,7 @@
 	struct gdlm_header *hd = (struct gdlm_header *)buf;
 	struct mg_member *memb;
 
-	log_group(mg, "receive_options from %d len %d last_cb %d",
+	log_group(mg, "receive_options from %d len %zd last_cb %d",
 		  from, len, mg->last_callback);
 
 	if (hd->nodeid == our_nodeid) {
@@ -1123,7 +1123,7 @@
 
 	count = (len - sizeof(struct gdlm_header)) / (NUM * sizeof(int));
 
-	log_group(mg, "receive_journals from %d to %d len %d count %d cb %d",
+	log_group(mg, "receive_journals from %d to %d len %zd count %d cb %d",
 		  from, hd->to_nodeid, len, count, mg->last_callback);
 
 	/* just like we can receive an options msg from a newly added node
@@ -1611,7 +1611,7 @@
 {
 	struct mountgroup *mg;
 	struct mg_member *memb;
-	char *ss;
+	const char *ss;
 	int rv, found = 0;
 
 	mg = find_mg(name);
@@ -2268,7 +2268,7 @@
 	   discard them since they're only relevant to the app group. */
 
 	if (!mg->last_callback) {
-		log_group(mg, "discard %s len %d from %d",
+		log_group(mg, "discard %s len %zd from %d",
 			  msg_name(hd->type), len, nodeid);
 		return;
 	}
